{Copyright (C) 2005-2008 (Patrick FRADIN)
Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon les termes de la Licence
Publique Générale GNU publiée par la Free Software Foundation (version 2 ou bien toute autre version
ultérieure choisie par vous).

Ce programme est distribué car potentiellement utile, mais SANS AUCUNE GARANTIE,
 ni explicite ni implicite, y compris les garanties de commercialisation ou d'adaptation dans un but spécifique.
 Reportez-vous à la Licence Publique Générale GNU pour plus de détails.

Vous devez avoir reçu une copie de la Licence Publique Générale GNU en même temps que ce programme;
 si ce n'est pas le cas, écrivez à la Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, États-Unis.
 }

unit SimpleGraph;
{$MODE Delphi}
 //droite cercle point spline bezier implicit
interface
 uses
  SysUtils, Classes, LcLType,
  
  {Windows, Messages,} Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  LResources, Buttons;
  
const    
    fbsSizeable=bsSizeable;
   
type

  { TSimpleGraphForm }

  TSimpleGraphForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label7: TLabel;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    //Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    //procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Déclarations privées }
  public
    { Déclarations publiques }
    function Valider: Boolean;
  end;

var
  SimpleGraphForm: TSimpleGraphForm;

implementation
uses calculs1, listes2, complex3, analyse4, command5, graph1_6, graph2_7, saisies, Unit1;


  

procedure TSimpleGraphForm.Button1Click(Sender: TObject);
begin
     if Valider then ModalResult:=mrOk else ModalResult:=mrNone;
end;

procedure TSimpleGraphForm.Button3Click(Sender: TObject);
begin
     MainForm.GestionAttributs(Edit1.text);
     Button1.SetFocus
end;

procedure TSimpleGraphForm.FormCreate(Sender: TObject);
var p:Pelement;
begin
     Font:=DefaultFont;
     {$IFDEF WINDOWS}
     Memo2.ParentFont:=true;
     {$ENDIF}

     digits:=12;
     p:=CurrentGraph;
     if currentCat=cat_utilisateur
                    then
                        begin
                                Width:=650;
                                BorderStyle:=fbsSizeable
                        end;
     Edit1.Text:=CurrentName;
     if p<>nil
        then
            begin
                 Edit2.text:=p^.LigneCommande;
                 case currentCat of
                 cat_label: edit3.text:=PLabel(p)^.texte;
                 cat_polygone: begin
                                 edit3.text:=Streel(PLigne(p)^.rayon);
                                 Checkbox1.checked:=(Pligne(p)^.fermee=1);
                               end;
                 cat_path: Checkbox1.checked:=(PPath(p)^.closelastpath);
                 cat_ellipticarc: Checkbox1.checked:=(Pellipticarc(p)^.sens=1);
                 cat_equadif: RadioGroup1.ItemIndex:=Pequadif(p)^.mode;
                 end;
                 p^.lireAttributs;
            end else
                    begin
                         DefaultSettings;
                         Edit2.Text:='[  ]';
                         case currentCat of
                         cat_label: edit3.text:='';
                         cat_polygone: begin
                                            edit3.text:='0';
                                            Checkbox1.checked:=false;
                                       end;
                         cat_path: Checkbox1.checked:=false;
                         cat_ellipticarc: Checkbox1.checked:=true;
                         cat_equadif: RadioGroup1.ItemIndex:=0;
                         end;

                    end;
     Case CurrentCat of
     cat_dot: begin
                      Caption:='Point ou nuage de points';
                      memo2.text:='Commande est une expression qui renvoie une liste de complexes (affixes).'
                      +CRLF+'Pour un nuage de points A1, A2..., An, tapez: [A1,A2,...,An]'
                      +CRLF+CRLF+'Exemple: [-1, 1+2*i, 3*exp(i*pi/4)]';
               end;
     cat_droite: begin
                      Caption:='Droite';
                      memo2.text:='Droite passant par deux points A et B, tapez: [A, B]  (ex: [3-i, 1+2*i] )'
                      +CRLF+'Droite passant par A et dirigée par le vecteur V, tapez: [A, A+V]'
                      +CRLF+'Droite d''équation ax+by=c, tapez: [a, b, c]'
                      +CRLF+CRLF+'Exemple: [0, 1+i]';
                 end;
     cat_ellipse: begin
                      Caption:='Ellipse';
                      memo2.text:='Ellipse de centre A et de rayons: rX, et rY avec une inclinaison en degrés par rapport à l''horizontal (nulle par défaut)'
                      +CRLF+'tapez: [A, rx, ry] ou [A, rx, ry, inclinaison]'
                      +CRLF+CRLF+'Exemple: [0, 2, 3, 45]';
                 end;
     cat_Spline: begin
                      Caption:='Spline cubique';
                      memo2.text:='La commande est une expression de la forme [V1,A1,A2,...,An,Vn] avec:'
                      +CRLF+'A1,...An: la liste des points interpolés par la spline,'
                       +CRLF+'V1: vecteur vitesse au point A1'
                      +CRLF+'et Vn: vecteur vitesse au point An (0 = pas de contrainte, extremité libre).'
                      +CRLF+CRLF+'Exemple: [0, -1, i, 1, 2-i, 0]';
                 end;
     cat_bezier: begin
                      Caption:='Courbe de Bezier';
                      memo2.text:='[A1,A2,A3]: on aura une courbe de Bézier à 3 points.'+CRLF+
                      '[A1,A2,A3,A4,...,A(3n+1)]: successions de courbes de Bézier joingnant les points A1, A4, A7, ..., A(3n+1),'+
                      'les autres points sont des points de contrôle. '+
                      'Deux points contrôles successifs peuvent être remplacés par un jump, dans ce cas la courbe de Bézier '+
                      ' est remplacée par un segment.'
                      +CRLF+CRLF+ 'Exemple: [-2, -1+i, i, 1, jump, 1-i, jump, -2-i, jump, -2]';
                 end;
     cat_implicit: begin
                      Caption:='Courbe implicite f(x,y)=0';
                      memo2.text:='La commande est une expression de la forme f(x,y) ou [f(x,y), n, m], avec:'
                      +CRLF+'n: le nombre d''intervalles (subdivision) en abscisse (50 par défaut),'
                      +CRLF+'et m: le nombre d''intervalles (sbdivision) en ordonnée (50 par défaut).'
                      +CRLF+CRLF+'Exemple: sin(x*y)';
                 end;
     cat_Label: begin
                      Caption:='Label';
                      Label3.Caption:='Affixe=';
                      Edit2.left:=edit1.Left; edit2.width:=edit1.width;
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-7;
                      memo2.text:='Le texte est une chaine de caractères'
                      +CRLF+CRLF+'Exemple: Ceci est un label';
                      Label7.Caption:='Texte=';
                      Label7.visible:=true;
                      Edit3.visible:=true;
                 end;
     cat_polygone: begin
                      Caption:='Ligne polygonale';
                      checkBox1.caption:='fermée';
                      checkBox1.visible:=true;
                      Label7.Caption:='Rayon=';
                      Edit3.Width:=Edit1.Width;
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-5;
                      memo2.text:='Pour une ligne polyg. A1, A2..., An, tapez la commande: [A1,A2,...,An]'
                      +CRLF+'Pour des <coins> arrondis donner un rayon >0.'
                      +CRLF+CRLF+'Exemple: [1, 1+i, 2-3*i]';
                      Label7.visible:=true;
                      Edit3.visible:=true;
                      checkBox1.visible:=true;
                 end;
     cat_path: begin
                      Caption:='Chemin';
                      checkBox1.caption:='fermer la dernière composante';
                      CheckBox1.left:=Edit1.left;
                      checkBox1.visible:=false;
                      checkBox1.anchors:=[akTop, akLeft];
                      checkBox1.left:=Edit1.left;
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-5;
                      memo2.text:='Un chemin est une liste constituée de points et d''instructions '+
                      'pour relier ces points. Ces instructions sont:'+CRLF+
                      'line (ligne polygonale),'+CRLF+
                      'linearc (ligne polygonale aux coins arrondis,'+
                        ' le point précédent la commande est interprêté comme un rayon),'+CRLF+
                      'arc (arc de cercle, comme la commande Arc: B,A,C,rayon,sens),'+CRLF+
                      'ellipticArc (arc d''ellipse, B,A,C,rX,rY,sens, inclinaison grand axe),'+CRLF+
                      'circle (cercle: point, centre ou trois points A,B,C),'+CRLF+
                      'ellipse (ellipse: point, centre, rX, rY, inclinaison grand axe),'+CRLF+
                      'bezier (courbe de bezier à 4 points),'+CRLF+
                      'move (indique un déplacement sans tracé),'+CRLF+
                      'closepath (pour fermer la dernière composante),'+CRLF+
                      'curve (courbe spline naturelle).'
                      +CRLF+CRLF+'Exemple: [-3+2*i,-3,-2,line,0,2,2,-1,arc,3,3+3*i,0.5,linearc,1,-1+5*i,-3+2*i,bezier]';
                      checkBox1.visible:=true;
                 end;
     cat_ellipticArc: begin
                      Caption:='Arc d''ellipse';
                      CheckBox1.left:=Edit1.left;
                      checkBox1.visible:=true;
                      checkBox1.anchors:=[akTop, akLeft];
                      CheckBox1.Caption:='Sens trigo';
                      memo2.top:=Edit3.top+Edit3.Height+2;
                      memo2.Height:=-memo2.top+Button1.top-7;
                      memo2.text:='Arc d''ellipse BAC de centre A de rayons Rx et Ry, tapez: [B, A, C, Rx, Ry]'
                      +CRLF+CRLF+'Exemple: [1, 0, -3+i, 2, 3]';
                      CheckBox1.visible:=true;
                 end;

     cat_Equadif: begin
                      Caption:='Equation différentielle: x''(t)+iy''(t)= f(t,x,y)';
                      RadioGroup1.visible:=true;
                      RadioGroup1.top:=memo2.top-7;
                      RadioGroup1.height:=memo2.height+7;
                      memo2.left:=RadioGroup1.left+Radiogroup1.Width+2;
                      memo2.Width:=Edit3.left+Edit3.width-memo2.left;
                      memo2.text:='Avec les conditions initiales: x(t0)=x0 et y(t0)=y0'
                      +CRLF+'tapez la commande: [f(t,x,y), t0, x0+i*y0]'
                      +CRLF+CRLF+'Exemple: [1+i*y, 0, i]';
                 end;
     end;
     digits:=4;
end;

{procedure TSimpleGraphForm.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     if key=VK_tab then
     begin
          Button1.SetFocus;
          Key:=0
     end;
end;}

function TSimpleGraphForm.Valider:boolean;
var nom:Tnom;
    p,q:Pelement;
    f:Pexpression;
    R:real;
    sens:integer;
    commande:string;
begin
     Valider:=true;
     nom:=Edit1.text;
     p:=CurrentGraph;
     if NomValide(nom,p<>nil) then
           begin
                 new(f,init);
                 commande:=Edit2.text;
                 if not f^.definir(commande)
                    then
                        begin
                             Messagedlg(ErrorMessage,mtWarning,[mbok],0);
                             Edit2.selStart:=ErrorPos-1;
                             Edit2.SelLength:=1;
                             Edit2.SetFocus;
                             Valider:=false
                        end
                    else
                         begin
                              //if p<>nil then liste_element.supprimer(Pcellule(p));
                              case CurrentCat of
                              cat_dot: q:=new(PDot,init(Nom,Edit2.Text));
                              cat_droite: q:=new(PDroite,init(Nom,Edit2.Text));
                              cat_ellipse: q:=new(Pellipse,init(Nom,Edit2.Text));
                              cat_implicit: q:=new(PImplicit,init(Nom,Edit2.Text));
                              cat_bezier: q:=new(PBezier,init(Nom,Edit2.Text));
                              cat_spline: q:=new(PSpline,init(Nom,Edit2.Text));
                              cat_label: q:=new(PLabel,init(Nom,Edit2.Text,Edit3.text));
                              cat_path:  q:=new(PPath,init(Nom,Edit2.text,byte(Checkbox1.checked)));
                              cat_polygone:  if validReal(edit3,0,reel_Max,R) then
                                            q:=new(Pligne,init(Nom,Edit2.text,byte(Checkbox1.checked),R))
                                            else begin Valider:=false; dispose(f,detruire); exit end;
                              cat_ellipticarc:  begin
                                               if checkbox1.checked then sens:=1 else sens:=-1;
                                               q:=new(PEllipticArc,init(Nom,Edit2.Text,sens));
                                        end;
                              cat_equadif:  q:=new(PEquadif,init(Nom,Edit2.Text,RadioGroup1.ItemIndex));
                              end;
                              if p=nil then ajouter_element(q)
                                       else begin
                                                 liste_element.inserer(q,p);
                                                 liste_element.supprimer(Pcellule(p));
                                            end;
                         end;
                 dispose(f,detruire)
           end
           else begin
                     Messagedlg(Edit1.text+': nom invalide ou déjà pris!',mtWarning,[mbok],0);
                     Edit1.selectAll; Edit1.SetFocus; Valider:=false
                end
end;

initialization

  {$i SimpleGraph.lrs}

end.
